import controlP5.*; //import ControlP5 library
import processing.serial.*;
import processing.video.*;
import cc.arduino.*;
Serial port;

ControlP5 cp5; //create ControlP5 object

PFont zigBlack;
Capture cam;
PImage img;
PImage header;
Arduino arduino;
int Servo_Motor_1=0;
int Servo_Motor_2=0;

void setup(){ 
size(1200, 700,P2D); 
background(255,220,220);
PFont font = createFont("Georgia",12); 
//camera starts
                                    String[] cameras = Capture.list();
                                    
                                    if (cameras.length == 0) {
                                      println("There are no cameras available for capture.");
                                      exit();
                                    } else {
                                      println("Available cameras:");
                                      for (int i = 0; i < cameras.length; i++) {
                                        println(cameras[i]);
                                      }
                                      
                                      // The camera can be initialized directly using an 
                                      // element from the array returned by list():
                                      cam = new Capture(this, cameras[0]);
                                      cam.start();     
                                    }   
 //camera over
  
  
  printArray(Serial.list());   //prints all available serial ports
  
  port = new Serial(this, "/dev/ttyACM0", 9600);  //i have connected arduino to /dev/ttyACM0, it would be different in windows and mac os
  
  cp5 = new ControlP5(this);
         zigBlack = createFont("Serif.bolditalic-48.vlw", 20); 
         font = createFont("CenturySchL-BoldItal-48", 18);    // custom fonts for buttons and title
  
  cp5.addButton("A")   
    .setPosition(20, 75)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
  
    cp5.addButton("B")   
    .setPosition(20, 125)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;   
  
    cp5.addButton("C")   
    .setPosition(20, 175)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
  
    cp5.addButton("D")   
    .setPosition(20, 225)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ; 
    cp5.addButton("E")   
    .setPosition(20, 275)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
  
    cp5.addButton("F")   
    .setPosition(20, 325)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;   
  
    cp5.addButton("G")   
    .setPosition(20, 375)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
  
    cp5.addButton("H")   
    .setPosition(20, 425)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ; 
    
    cp5.addButton("I")   
    .setPosition(20, 475)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ; 
    cp5.addButton("J")   
    .setPosition(20, 525)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
  
    cp5.addButton("K")   
    .setPosition(20, 575)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;   
  
    cp5.addButton("L")   
    .setPosition(20, 625)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
  

  cp5.addButton("M")     
    .setPosition(170, 75) 
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))    
    
  ;
  
      cp5.addButton("N")   
    .setPosition(170, 125)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;   
  
    cp5.addButton("O")   
    .setPosition(170, 175)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
  
    cp5.addButton("P")   
    .setPosition(170, 225)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ; 
    cp5.addButton("Q")   
    .setPosition(170, 275)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
  
    cp5.addButton("R")   
    .setPosition(170, 325)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;   
  
    cp5.addButton("S")   
    .setPosition(170, 375)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
  
    cp5.addButton("T")   
    .setPosition(170, 425)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ; 
    
    cp5.addButton("U")   
    .setPosition(170, 475)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ; 
    cp5.addButton("V")   
    .setPosition(170, 525)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
  
    cp5.addButton("W")   
    .setPosition(170, 575)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;   
  
    cp5.addButton("X")   
    .setPosition(170, 625)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;
    cp5.addButton("Y")     
    .setPosition(320, 325) 
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))    
    
  ;
  
      cp5.addButton("Z")   
    .setPosition(320, 375)  
    .setSize(120, 40)     
    .setFont(font)
               .setColorValue(color(0))
               .setColorLabel(0)
               .setColorActive(color(255,0,0))
               .setColorForeground(color(200,200,200)) 
               .setColorBackground(color(255,0,0))
    
  ;   
  img = loadImage("robot.png"); 
  header = loadImage("header.png");
}

void draw(){  
 if (cam.available() == true) {
    cam.read();
  }
  image(cam, 450, 75,740,480);
  image(header, 0, 5, 1200, 50);
  image(img, 450, 580, 740, 40);
}

void A(){
  port.write('a');
}
void B(){
  port.write('b');
}
void C(){
  port.write('c');
}
void D(){
  port.write('d');
}
void E(){
  port.write('e');
}
void F(){
  port.write('f');
}
void G(){
  port.write('g');
}
void H(){
  port.write('h');
}
void I(){
  port.write('i');
}
void J(){
  port.write('j');
}
void K(){
  port.write('k');
}
void L(){
  port.write('l');
}
void M(){
  port.write('m');
}
void N(){
  port.write('n');
}
void O(){
  port.write('o');
}
void P(){
  port.write('p');
}
void Q(){
  port.write('q');
}
void R(){
  port.write('r');
}
void S(){
  port.write('s');
}
void T(){
  port.write('t');
}
void U(){
  port.write('u');
}
void V(){
  port.write('v');
}
void W(){
  port.write('w');
}
void X(){
  port.write('x');
}
void Y(){
  port.write('y');
}
void Z(){
  port.write('z');
}